attribute vec4 vert_position;
attribute vec3 vert_axisX;
attribute vec3 vert_axisY;
attribute vec2 vert_scalerVerti;
attribute vec4 vert_color;

varying mediump vec3 color;
varying mediump vec3 lcampos;
varying mediump vec3 lpos;
varying mediump vec3 zconvert;


uniform vec3 camx;
uniform vec3 camy;
uniform vec3 camz;
uniform vec3 camw;
uniform vec3 screenScale;
uniform vec3 objcampos;
uniform vec3 objcamz;

vec4 transformA(vec3 pos)
{
	vec4 tpos;
	tpos.xyw = 
		camx*pos.x +
		camy*pos.y +
		camz*pos.z +
		camw;
	tpos.z = 0.0;
	return tpos;
}

void main()
{
	vec4 tpos;

	vec3 wpos = vert_position.xyz;
	vec3 wcenter = wpos;

	vec3 axisz = cross(vert_axisX,vert_axisY)*vert_scalerVerti.x;
	vec3 axisx = vert_axisX;
	vec3 axisy = vert_axisY;
	float  verti = float(vert_scalerVerti.y);
	vec3 cubeloc = vec3( mod(verti,2.0),  mod( floor(verti/2.0),2.0),floor(verti/4.0))*2.0-1.0;
	wpos += cubeloc.x*axisx;
	wpos += cubeloc.y*axisy;
	wpos += cubeloc.z*axisz;

	tpos = transformA(wpos);
		
	tpos.xy *= screenScale.xy;
	tpos.z = tpos.w-1.0; // near plane
    gl_Position = tpos;
	color = vert_color.xyz*0.5;


	lcampos.x = dot(objcampos-wcenter,axisx)/dot(axisx,axisx);
	lcampos.y = dot(objcampos-wcenter,axisy)/dot(axisy,axisy);
	lcampos.z = dot(objcampos-wcenter,axisz)/dot(axisz,axisz);
	lpos = cubeloc;		

	zconvert.x = dot(axisx,objcamz);
	zconvert.y = dot(axisy,objcamz);
	zconvert.z = dot(axisz,objcamz);
}
