attribute vec4 vert_position;
attribute vec4 vert_color;
attribute vec3 vert_normal;
attribute vec3 vert_texcoord;

varying mediump vec4 color;
varying mediump vec2 texcoord;
varying mediump vec3 locnormal;

struct TRANS
{
	vec3 camx;
	vec3 camy;
	vec3 camz;
	vec3 camw;
};


uniform vec3 screenScale;
uniform mediump vec3 lightDir;
uniform mediump vec3 lightDirAmbient;

//uniform TRANS trans[10];
uniform TRANS t00;
uniform TRANS t01;
uniform TRANS t02;
uniform TRANS t03;
uniform TRANS t04;
uniform TRANS t05;
uniform TRANS t06;
uniform TRANS t07;
uniform TRANS t08;
uniform TRANS t09;


// mesh transform
void main()
{
	vec4 tpos;
	mediump vec3 cnormal,cdiru,cdirv;

/*	TRANS t = trans[int(vert_texcoord.z)];
	tpos.xyw = 
		t.camx*vert_position.x +
		t.camy*vert_position.y +
		t.camz*vert_position.z +
		t.camw;


	cnormal = 
		t.camx*vert_normal.x +
		t.camy*vert_normal.y +
		t.camz*vert_normal.z;*/
		

	tpos.xyw = 
		(t00.camx*vert_position.x +
		t00.camy*vert_position.y +
		t00.camz*vert_position.z +
		t00.camw)*(vert_texcoord.z==0.0 ? 1.0 : 0.0) + 
		(t01.camx*vert_position.x +
		t01.camy*vert_position.y +
		t01.camz*vert_position.z +
		t01.camw)*(vert_texcoord.z==1.0 ? 1.0 : 0.0) + 
		(t02.camx*vert_position.x +
		t02.camy*vert_position.y +
		t02.camz*vert_position.z +
		t02.camw)*(vert_texcoord.z==2.0 ? 1.0 : 0.0) + 
		(t03.camx*vert_position.x +
		t03.camy*vert_position.y +
		t03.camz*vert_position.z +
		t03.camw)*(vert_texcoord.z==3.0 ? 1.0 : 0.0) + 
		(t04.camx*vert_position.x +
		t04.camy*vert_position.y +
		t04.camz*vert_position.z +
		t04.camw)*(vert_texcoord.z==4.0 ? 1.0 : 0.0) + 
		(t05.camx*vert_position.x +
		t05.camy*vert_position.y +
		t05.camz*vert_position.z +
		t05.camw)*(vert_texcoord.z==5.0 ? 1.0 : 0.0) + 
		(t06.camx*vert_position.x +
		t06.camy*vert_position.y +
		t06.camz*vert_position.z +
		t06.camw)*(vert_texcoord.z==6.0 ? 1.0 : 0.0) + 
		(t07.camx*vert_position.x +
		t07.camy*vert_position.y +
		t07.camz*vert_position.z +
		t07.camw)*(vert_texcoord.z==7.0 ? 1.0 : 0.0) + 
		(t08.camx*vert_position.x +
		t08.camy*vert_position.y +
		t08.camz*vert_position.z +
		t08.camw)*(vert_texcoord.z==8.0 ? 1.0 : 0.0) + 
		(t09.camx*vert_position.x +
		t09.camy*vert_position.y +
		t09.camz*vert_position.z +
		t09.camw)*(vert_texcoord.z==9.0 ? 1.0 : 0.0)
		;
		
	cnormal = 
		(t00.camx*vert_normal.x +
		t00.camy*vert_normal.y +
		t00.camz*vert_normal.z )*(vert_texcoord.z==0.0 ? 1.0 : 0.0) + 
		(t01.camx*vert_normal.x +
		t01.camy*vert_normal.y +
		t01.camz*vert_normal.z )*(vert_texcoord.z==1.0 ? 1.0 : 0.0) + 
		(t02.camx*vert_normal.x +
		t02.camy*vert_normal.y +
		t02.camz*vert_normal.z )*(vert_texcoord.z==2.0 ? 1.0 : 0.0) + 
		(t03.camx*vert_normal.x +
		t03.camy*vert_normal.y +
		t03.camz*vert_normal.z )*(vert_texcoord.z==3.0 ? 1.0 : 0.0) + 
		(t04.camx*vert_normal.x +
		t04.camy*vert_normal.y +
		t04.camz*vert_normal.z )*(vert_texcoord.z==4.0 ? 1.0 : 0.0) + 
		(t05.camx*vert_normal.x +
		t05.camy*vert_normal.y +
		t05.camz*vert_normal.z )*(vert_texcoord.z==5.0 ? 1.0 : 0.0) + 
		(t06.camx*vert_normal.x +
		t06.camy*vert_normal.y +
		t06.camz*vert_normal.z )*(vert_texcoord.z==6.0 ? 1.0 : 0.0) + 
		(t07.camx*vert_normal.x +
		t07.camy*vert_normal.y +
		t07.camz*vert_normal.z )*(vert_texcoord.z==7.0 ? 1.0 : 0.0) + 
		(t08.camx*vert_normal.x +
		t08.camy*vert_normal.y +
		t08.camz*vert_normal.z )*(vert_texcoord.z==8.0 ? 1.0 : 0.0) + 
		(t09.camx*vert_normal.x +
		t09.camy*vert_normal.y +
		t09.camz*vert_normal.z )*(vert_texcoord.z==9.0 ? 1.0 : 0.0)
		;
		
	tpos.xy *= screenScale.xy;
	tpos.z = tpos.w-1.0; // near plane

    gl_Position = tpos;
	

	vec3 ambientColor = mix( vec3(0.5,0.75,1)*0.85, vec3(0.15,0.3,0)*0.85, (1.0-dot(cnormal,lightDirAmbient))/2.0);
	vec3 diffuseColor = vec3(1.0,0.75,0.5) * max(dot(cnormal,lightDir),0.0);
	color.xyz = (diffuseColor + ambientColor ) * screenScale.z*vert_color.xyz;
//	color.xyz = vec3(0.5,0.5,0.5);
	color.w = 1.0;

	texcoord.xy = vert_texcoord.xy;

	locnormal.xyz = vert_normal.xyz;
}