attribute vec4 vert_position;
attribute vec4 vert_color;
attribute vec3 vert_texcoord;


struct TRANS
{
	vec3 camx;
	vec3 camy;
	vec3 camz;
	vec3 camw;
};


uniform vec3 screenScale;
uniform mediump vec4 shadowPlane;
uniform mediump vec3 lightDir;

//uniform TRANS trans[20];
uniform TRANS t00;
uniform TRANS t01;
uniform TRANS t02;
uniform TRANS t03;
uniform TRANS t04;
uniform TRANS t05;
uniform TRANS t06;
uniform TRANS t07;
uniform TRANS t08;
uniform TRANS t09;
uniform TRANS t10;
uniform TRANS t11;
uniform TRANS t12;
uniform TRANS t13;
uniform TRANS t14;
uniform TRANS t15;
uniform TRANS t16;
uniform TRANS t17;
uniform TRANS t18;
uniform TRANS t19;


// mesh transform
void main()
{
	vec4 tpos;
/*	TRANS t = trans[int(vert_texcoord.z)];
	vec3 cpos =
		t.camx*vert_position.x +
		t.camy*vert_position.y +
		t.camz*vert_position.z +
		t.camw;*/

	vec3 cpos = 
		(t00.camx*vert_position.x +
		t00.camy*vert_position.y +
		t00.camz*vert_position.z +
		t00.camw)*(vert_texcoord.z==0.0 ? 1.0 : 0.0) + 
		(t01.camx*vert_position.x +
		t01.camy*vert_position.y +
		t01.camz*vert_position.z +
		t01.camw)*(vert_texcoord.z==1.0 ? 1.0 : 0.0) + 
		(t02.camx*vert_position.x +
		t02.camy*vert_position.y +
		t02.camz*vert_position.z +
		t02.camw)*(vert_texcoord.z==2.0 ? 1.0 : 0.0) + 
		(t03.camx*vert_position.x +
		t03.camy*vert_position.y +
		t03.camz*vert_position.z +
		t03.camw)*(vert_texcoord.z==3.0 ? 1.0 : 0.0) + 
		(t04.camx*vert_position.x +
		t04.camy*vert_position.y +
		t04.camz*vert_position.z +
		t04.camw)*(vert_texcoord.z==4.0 ? 1.0 : 0.0) + 
		(t05.camx*vert_position.x +
		t05.camy*vert_position.y +
		t05.camz*vert_position.z +
		t05.camw)*(vert_texcoord.z==5.0 ? 1.0 : 0.0) + 
		(t06.camx*vert_position.x +
		t06.camy*vert_position.y +
		t06.camz*vert_position.z +
		t06.camw)*(vert_texcoord.z==6.0 ? 1.0 : 0.0) + 
		(t07.camx*vert_position.x +
		t07.camy*vert_position.y +
		t07.camz*vert_position.z +
		t07.camw)*(vert_texcoord.z==7.0 ? 1.0 : 0.0) + 
		(t08.camx*vert_position.x +
		t08.camy*vert_position.y +
		t08.camz*vert_position.z +
		t08.camw)*(vert_texcoord.z==8.0 ? 1.0 : 0.0) + 
		(t09.camx*vert_position.x +
		t09.camy*vert_position.y +
		t09.camz*vert_position.z +
		t09.camw)*(vert_texcoord.z==9.0 ? 1.0 : 0.0) +

		(t10.camx*vert_position.x +
		t10.camy*vert_position.y +
		t10.camz*vert_position.z +
		t10.camw)*(vert_texcoord.z==10.0 ? 1.0 : 0.0) + 
		(t11.camx*vert_position.x +
		t11.camy*vert_position.y +
		t11.camz*vert_position.z +
		t11.camw)*(vert_texcoord.z==11.0 ? 1.0 : 0.0) + 
		(t12.camx*vert_position.x +
		t12.camy*vert_position.y +
		t12.camz*vert_position.z +
		t12.camw)*(vert_texcoord.z==12.0 ? 1.0 : 0.0) + 
		(t13.camx*vert_position.x +
		t13.camy*vert_position.y +
		t13.camz*vert_position.z +
		t13.camw)*(vert_texcoord.z==13.0 ? 1.0 : 0.0) + 
		(t14.camx*vert_position.x +
		t14.camy*vert_position.y +
		t14.camz*vert_position.z +
		t14.camw)*(vert_texcoord.z==14.0 ? 1.0 : 0.0) + 
		(t15.camx*vert_position.x +
		t15.camy*vert_position.y +
		t15.camz*vert_position.z +
		t15.camw)*(vert_texcoord.z==15.0 ? 1.0 : 0.0) + 
		(t16.camx*vert_position.x +
		t16.camy*vert_position.y +
		t16.camz*vert_position.z +
		t16.camw)*(vert_texcoord.z==16.0 ? 1.0 : 0.0) + 
		(t17.camx*vert_position.x +
		t17.camy*vert_position.y +
		t17.camz*vert_position.z +
		t17.camw)*(vert_texcoord.z==17.0 ? 1.0 : 0.0) + 
		(t18.camx*vert_position.x +
		t18.camy*vert_position.y +
		t18.camz*vert_position.z +
		t18.camw)*(vert_texcoord.z==18.0 ? 1.0 : 0.0) + 
		(t19.camx*vert_position.x +
		t19.camy*vert_position.y +
		t19.camz*vert_position.z +
		t19.camw)*(vert_texcoord.z==19.0 ? 1.0 : 0.0)
		;

	cpos -= lightDir.xyz*(dot(cpos,shadowPlane.xyz)+shadowPlane.w);

	tpos.xyw = cpos.xyz;
		
	tpos.xy *= screenScale.xy;
	tpos.z = tpos.w-1.0;

    gl_Position = tpos;

}