attribute vec4 vert_position;
attribute vec4 vert_color;
//attribute vec3 vert_normal;
//attribute vec3 vert_texcoord;

varying mediump vec4 color;

struct TRANS
{
	vec3 camx;
	vec3 camy;
	vec3 camz;
	vec3 camw;
};


uniform vec3 screenScale;

uniform TRANS trans;


// mesh transform
void main()
{
	vec4 tpos;
	TRANS t = trans;

	tpos.xyw = 
		t.camx*vert_position.x +
		t.camy*vert_position.y +
		t.camz*vert_position.z +
		t.camw;
		
	tpos.xy *= screenScale.xy;
	tpos.z = tpos.w-1.0; // near plane

    gl_Position = tpos;
	
	color = vert_color.zyxw/255.0;

}